function goto_file() {
	document.getElementById('filename').focus();
};

function login() {
	var userid = document.getElementById('user_id');
	var pass = document.getElementById('password');
	var rem = document.getElementById('remember');
	if (loginuser(userid.value, pass.value, rem.checked, false))
        userid.value = "";
    pass.value = "";
    rem.checked = false;
};
function loginuser(user, pass, remember, supressAlerts, auto) {
    var button = document.getElementById('loginBtn');
    button.disabled = true;
    if (loop.isTempUser(user))
        pass = '';
	var loginString = 'user_id='+encodeURIComponent(user)+'&password='+encodeURIComponent(pass);
	var strings = document.getElementById("bundleloop");
	var badLogin = strings.getString("bad.login");
	var problemLogin = strings.getString("problem.logging");
    var legal_un = /^([0-9a-zA-Z]([-.\w]*[0-9a-zA-Z])*@(([0-9a-zA-Z])+([-\w]*[0-9a-zA-Z])*\.)+[a-zA-Z]{2,9})$/;
    var legal_pw = /^[^<]+?[<>]*?$/;
    if (auto || (user.match(legal_un) && pass.match(legal_pw)))
    {
    	var xmlr = new XMLHttpRequest();
    	xmlr.open("POST", "http://"+loop.domain+"/login?i="+loop.Interface, false);
    	xmlr.setRequestHeader("Content-Length", loginString.length);
    	xmlr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    	xmlr.send(loginString);
    	if(xmlr.readyState == 4 && xmlr.status == 200) {
    		if(xmlr.getResponseHeader("LoginStatus") == "BAD") {
    			if(!supressAlerts)
    				alert(badLogin);
    		} else if (xmlr.getResponseHeader("Content-Location") && xmlr.getResponseHeader("Content-Location").toLowerCase().indexOf("error") > -1) {
            	if(!supressAlerts)
                    alert(problemLogin);
            } else {
    			logout();
    			if(remember)
                {
                    if (!user)
                        user = xmlr.getResponseHeader("UserID");
    				loop.saveUser(user, pass);
                }
    			updatelogin(user);
                button.disabled = false;
    			return true;
    		}
    	} else {
    		if(!supressAlerts)
    			alert(problemLogin);
    	}
    }
    else if(!supressAlerts)
        alert(badLogin);
    button.disabled = false;
	return false;
};

function go_faq() {
	loop.openURL(loop.faq());
};

function goCorpSite() {
    loop.openURL(loop.corpSite());
};

function reset_password() {
	loop.openURL(loop.password());
};

function register() {
	loop.openURL(loop.register());
};

function logged_out() {
	document.getElementById('username').value = '';
	document.getElementById('selected').collapsed = true;
	document.getElementById('login_section').collapsed = false;
	document.getElementById('userinfo').hidden = true;
	document.getElementById('addfile').disabled = document.getElementById('advanced').disabled = true;
	document.getElementById('combine_all').disabled = document.getElementById('filename').disabled = true;
	document.getElementById('user_id').focus();
};

function logged_in() {
	document.getElementById('addfile').disabled = document.getElementById('advanced').disabled = false;
    document.getElementById('filename').disabled = false;
	document.getElementById('selected').collapsed = false;
	document.getElementById('login_section').collapsed = true;
	document.getElementById('userinfo').hidden = false;
	document.getElementById('sbFireLoop').focus();
};

function init() {
	document.getElementById('login_section').collapsed = true;
    document.getElementById('username').value = '';
	document.getElementById('userinfo').hidden = true;
    document.getElementById('logged_in_text').collapsed = true;
    document.getElementById('footer_spacer').collapsed = true;
    document.getElementById('login').collapsed = false;
    document.getElementById('logout').collapsed = true;

	document.getElementById('addfile').disabled = document.getElementById('advanced').disabled = true;
	document.getElementById('combine_all').disabled = document.getElementById('filename').disabled = true;
	document.getElementById('main_panel').collapsed = false;
	update_combine();
	//logged_out();
	var userInfo = loop.getUser();
    var username = '';
    var password = '';
    //ff2
    if (userInfo.user)
    {
        username = userInfo.user;
        password = userInfo.pass;
    }
    //ff3
    else if (userInfo.username)
    {
        username = userInfo.username;
        password = userInfo.password;
    }
    if (loginuser(username, password, true, true, true))
    {
        logged_in();
    }
    else
    {
        logged_out();
    }
};

function true_logout() {
	var xmlr = new XMLHttpRequest();
	xmlr.open("GET", "http://"+loop.domain+"/logout?i="+loop.Interface, true);
	xmlr.send(null);
	logout();
};

function logout() {
	clearFiles();
	loop.removeUser();
	update_combine();
	logged_out();
};

function clearFiles() {
	var sel = document.getElementById('selected');
	for(var i = sel.getRowCount() - 1; i >= 0; i--) {
		var file = sel.getItemAtIndex(i).owner;
		file.removeRow(false);
	}
	update_combine();
};

function move_up() {
	var sel = document.getElementById('selected');
	var si = sel.selectedIndex;
	if(si && si > 0) {
		var rows = new Array();
		for(var i = 0; i < si - 1; i++)
			rows[rows.length] = sel.getItemAtIndex(i);
		rows[rows.length] = sel.getItemAtIndex(si);
		rows[rows.length] = sel.getItemAtIndex(si - 1);
		for(var i = si + 1; i < sel.getRowCount(); i++)
			rows[rows.length] = sel.getItemAtIndex(i);
		for(var i = 0; i < rows.length; i++) {
			sel.appendChild(rows[i]);
			rows[i].owner.attachEvents();
		}
		sel.selectedIndex = si - 1;
	}
	select_item();
	update_combine();
};

function move_down() {
	var sel = document.getElementById('selected');
	var si = sel.selectedIndex;
	if(si >= 0 && si < sel.getRowCount() - 1) {
		var rows = new Array();
		for(var i = 0; i < si; i++)
			rows[rows.length] = sel.getItemAtIndex(i);
		rows[rows.length] = sel.getItemAtIndex(si + 1);
		rows[rows.length] = sel.getItemAtIndex(si);
		for(var i = si + 2; i < sel.getRowCount(); i++)
			rows[rows.length] = sel.getItemAtIndex(i);
		for(var i = 0; i < rows.length; i++) {
			sel.appendChild(rows[i]);
			rows[i].owner.attachEvents();
		}
		sel.selectedIndex = si + 1;
	}
	select_item();
	update_combine();
};

function select_item() {
	var sel = document.getElementById('selected');
	var cur = sel.selectedIndex;
	var max = sel.getRowCount() - 1;
	document.getElementById('movedown').disabled = (!(cur >= 0 && cur < max));
	document.getElementById('moveup').disabled = (!(cur <= max && cur > 0));
};

function updatelogin(user) {
    if (loop.isTempUser(user))
    {
        document.getElementById('username').value = '';
        document.getElementById('logged_in_text').collapsed = true;
        document.getElementById('footer_spacer').collapsed = true;
        document.getElementById('login').collapsed = false;
        document.getElementById('logout').collapsed = true;
    }
    else
    {
        document.getElementById('username').value = user;
        document.getElementById('logged_in_text').collapsed = false;
        document.getElementById('footer_spacer').collapsed = false;
        document.getElementById('login').collapsed = true;
        document.getElementById('logout').collapsed = false;
    }
	logged_in();
	update_combine();
	clearFiles();
    var request = new XMLHttpRequest();
    request.open("GET", "http://"+loop.domain+"/files?xml=true&i="+loop.Interface, false);
    request.send(null);
    if(request.readyState == 4 && request.status == 200) {
        var response = request.responseXML.documentElement;
        var ef = response.getElementsByTagName('file');
        for(var i = 0; i < ef.length; i++) {
            var f = new File(ef[i].firstChild.data);
            f.createRow(document.getElementById('selected'));
            f.updateCallback = update_combine;
            f.updateRow();
        }
    }
};

function update_combine() {
	var combinable = 0;
	var sel = document.getElementById('selected');
    if (!sel.collapsed) {
	for(var i = 0; i < sel.getRowCount(); i++)
    		if(sel.getItemAtIndex(i).owner.completed && (sel.getItemAtIndex(i).owner.status == "ok" || sel.getItemAtIndex(i).owner.status == "error"))
    			combinable++;
    	document.getElementById('combine_all').disabled = (combinable != sel.getRowCount());
    }
};

function choose_file(event) {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

	var strings = document.getElementById("bundleloop");
	var selectFile = strings.getString("select.file");

	fp.init(window, selectFile, nsIFilePicker.modeOpen);
	var res = fp.show();
	if(res == nsIFilePicker.returnOK) {
		var f = new File(fp.file);
		f.createRow(document.getElementById('selected'));
		f.updateCallback = update_combine;
		f.upload();
	}
	update_combine();
};

function merge_all(name, files) {
	var sel = document.getElementById('selected');
	if(sel.getRowCount() > 0) {
        if (!sel.collapsed) {
            document.getElementById('combine_all').disabled = true;
        }
		var url = "http://"+loop.domain+"/packages/loop?i="+loop.Interface;

        var form = document.getElementById('download_handle');
        form.innerHTML = "";
        		
		var post = "";
        var sNum = 1;
        
        if (files) {
            for (var i = 0; i < files.length; i++) {
                var file = files[i];
                
                if (file.completed && file.status == 'ok') {
                    addInput(form, null, 'section_'+(sNum++), '/files/'+file.filename+'/PDF');
                }
            }
        }
        // if files not specified, combine all
        else {
    		for(var i = 0; i < sel.getRowCount(); i++) {
    			var file = sel.getItemAtIndex(i).owner;
                
    			if(file.completed && file.status == "ok") {
                    addInput(form, null, 'section_'+(sNum++), '/files/'+file.filename+'/PDF');
                }
    		}
        }

		var filename = (name != undefined ? name : document.getElementById('filename').value);
		if(filename != "")
			url += "&filename="+encodeURIComponent(filename);

        form.action = url;
        form.submit();
        if (!sel.collapsed) {
            document.getElementById('combine_all').disabled = false;
        }
	}
};

function showLoopSection() {
    document.getElementById('login_section').collapsed = true;
    document.getElementById('selected').collapsed = false;
    document.getElementById('addfile').disabled 
        = document.getElementById('advanced').disabled
        = document.getElementById('moveup').disabled 
        = document.getElementById('movedown').disabled
        = document.getElementById('combine_all').disabled 
        = document.getElementById('filename').disabled = false;    
    
};

function addInput(form, element, name, value) {
    var val = (value != undefined ? value : getFormValue(element));
    if (val != undefined) {
        var input = document.createElementNS('http://www.w3.org/1999/xhtml', 'html:input');
        input.type = 'hidden';
        input.name = name || element.getAttribute('name');
        input.value = val;
        form.appendChild(input);
    }
};

function getFormValue(element) {
    if (element && element.nodeName) {
        if (element.nodeName.toLowerCase() == 'checkbox') {
            if (element.checked) {
                return 'on';
            }
        }
        else {
            return element.value;
        }
    }
    return undefined;
};

function addOverlay(element) {
    element.style['opacity'] = '.3';
    var pSection = document.getElementById('processing');
    if (pSection) {
        pSection.style['display'] = 'block';
        pSection.top = element.getBoundingClientRect().top;
    }
};

function removeOverlay(element) {
    var pSection = document.getElementById('processing');
    if (pSection) {
        pSection.style['display'] = 'none';
    }
    element.style['opacity'] = '1';
};

function login_helper() {
	window.openDialog("chrome://fireloop/content/login.xul", "_blank", "chrome,modal,dialog,centerscreen");
};

function delete_selected() {
	var sel = document.getElementById('selected');
	var si = sel.selectedIndex;
	if(si >= 0 && si < sel.getRowCount()) {
		sel.getItemAtIndex(si).owner.removeRow(true);
	}
	update_combine();
	if(si >= sel.getRowCount());
		si = sel.getRowCount() - 1;
	if(si < 0)
		si = 0;
	if(sel.getRowCount() > 0)
		sel.selectedIndex = si;
};

function download_selected() {
	var sel = document.getElementById('selected');
	var si = sel.selectedIndex;
	if(si >= 0 && si < sel.getRowCount()) {
		var obj = sel.getItemAtIndex(si).owner;
		if(obj.downloadclick)
			obj.downloadclick();
	}
	update_combine();
};

function handle_enter(id, event) {
	if(event.keyCode == 13) {
		var cmd = document.getElementById(id);
		if(cmd)
			cmd.doCommand();
	}
};

function goto_advanced() {
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow('navigator:browser');
	var browser = topWindow.document.getElementById("content");
	browser.selectedTab = browser.addTab("http://"+loop.domain+"/loop/order");
};